import numeric.*;

public class Exc020202 {
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		EquationSolver solver = new EquationSolver();
		solver.setNumIterations(5);
		Function g1 = new TestFunction1();
		Function g2 = new TestFunction2();
		Function g3 = new TestFunction3();
		new EquationDemoView(solver);
		try {
			solver.fixedPoint(g1, 1.0);
		} catch (ArithmeticException e) {
			System.err.println(e.getMessage());
		}
		new EquationDemoView(solver);
		try {
			solver.fixedPoint(g2, 1.0);
		} catch (ArithmeticException e) {
			System.err.println(e.getMessage());
		}
		new EquationDemoView(solver);
		try {
			solver.fixedPoint(g3, 1.0);
		} catch (ArithmeticException e) {
			System.err.println(e.getMessage());
		}
	}

	private static class TestFunction1 implements Function {
		public double value(double x) {
			return Math.pow(3 + x - 2*x*x, 1.0/4);
		}
	}

	private static class TestFunction2 implements Function {
		public double value(double x) {
			return Math.sqrt((x + 3 - x*x*x*x)/2);
		}
	}

	private static class TestFunction3 implements Function {
		public double value(double x) {
			return Math.sqrt((x + 3) / (x*x + 2));
		}
	}
}
