/**
 * <p>File: Exm020401.java</p>
 * <p>Title: Numerical methods</p>
 * <p>Description: Course on numerical analysis</p>
 * <p>Date: December 2011</p>
 * @author Faton M. Berisha
 * @version 6.0.0
 */

import numeric.*;

public class Exm020401 {
	public static void main(String[] args) {
		EquationSolver solver1 = new EquationSolver();
		solver1.setTolerance(1E-40);
		solver1.setNumIterations(8);

		EquationSolver solver2 = new EquationSolver();
		solver2.setTolerance(1E-40);
		solver2.setNumIterations(8);

		Function g1 = new IterativeFunction1();
		Function g2 = new IterativeFunction2();

		new EquationDemoView(solver1);
		new EquationDemoView(solver2);

		EquationDemoView.setNumSignificantDigits(10);

		try {
			solver1.fixedPoint(g1, 0.5);
		} catch (ArithmeticException e) {
			System.err.println(e.getMessage());
		}

		try {
			solver2.fixedPoint(g2, 0.5);
		} catch (ArithmeticException e) {
			System.err.println(e.getMessage());
		}

	}

	private static class IterativeFunction1 implements Function {
		public double value(double x) {
			return 0.5 * x;
		}
	}

	private static class IterativeFunction2 implements Function {
		public double value(double x) {
			return 0.5 * x * x;
		}
	}
}
