import numeric.*;

public class Exm020402 {
	public static void main(String[] args) {
		EquationSolver solverA = new EquationSolver();
		solverA.setTolerance(1E-10);
		solverA.setNumIterations(16);

		EquationSolver solverB = new EquationSolver();
		solverB.setTolerance(1E-10);
		solverB.setNumIterations(16);

		Differentiable f = new DiffFuncMult();
		Differentiable mu = new DiffFunc();

		new EquationDemoView("Metoda e Newton-it", solverA);
		new EquationDemoView("Metoda e Newton-it pr zero t dyfisht", solverB);

		EquationDemoView.setNumSignificantDigits(8);

		try {
			solverA.newton(f, 1.0);
		} catch (ArithmeticException e) {
			System.err.println(e.getMessage());
		}


		try {
			solverB.newton(mu, 1.0);
		} catch (ArithmeticException e) {
			System.err.println(e.getMessage());
		}
}

	private static class DiffFuncMult implements Differentiable {
		public double value(double x) {
			return Math.exp(x) - x - 1;
		}

		public double derivative(double x) {
			return Math.exp(x) - 1;
		}
	}

	private static class DiffFunc implements Differentiable {
		public double value(double x) {
			return (Math.exp(x) - x - 1) / (Math.exp(x) - 1);
		}

		public double derivative(double x) {
			return (Math.pow(Math.exp(x) - 1, 2)
						- (Math.exp(x) - x - 1)*Math.exp(x))
					/ Math.pow(Math.exp(x) - 1, 2);
		}
	}
}
