/**
 * <p>File: Exm060305.java</p>
 * <p>Title: Numerical methods</p>
 * <p>Description: Course on numerical analysis</p>
 * <p>Date: June 2009</p>
 * @author Faton M. Berisha
 * @version 4.01
 */

import numeric.*;

/**
 * Chapter 6: Direct Methods for Solving Linear Systems
 * Section 3: Linear Algebra and Matrix Inversion
 * Example 5
 */
public class Exm060305 {
	public static void main (String[] args) {
		double[][] coeff =
		{{ 1, 2, -1, 1, 0, 0},
		 { 2, 1,  0, 0, 1, 0},
		 {-1, 1,  2, 0, 0, 1}};
	
		Matrix matrix = new Matrix(coeff);
		matrix.setDemo(true);
		new MatrixView("Blok matrica", matrix);
		matrix.gaussJordan();
		
		int n = 3;
		Matrix inverse = new Matrix(n, n);
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < n; j++) {
				inverse.set(i, j, matrix.get(i, j + n));
			}
		}
		new MatrixView("Matrica inverse", inverse);
	}
}
