/**
 * <p>File: TestLinearSystem.java</p>
 * <p>Title: Numerical methods</p>
 * <p>Description: Course on numerical analysis</p>
 * <p>Date: June 2007</p>
 * @author Faton M. Berisha
 * @version 2.01
 */

// import javax.swing.*;
import numeric.*;

public class TestLinearSystem {
	public static void main(String[] args) {
/*		try {
			int n = 0;
			String input =
				JOptionPane.showInputDialog("Ju lutem jepni rendin e sistemit");
			n = new Integer(input).intValue();
		}
		catch ( NumberFormatException e ) {
//			AbstractSystemSolver.err.println(e);
			JOptionPane.showMessageDialog(null, "Input jokorrekt",
					"Gabim!", JOptionPane.ERROR_MESSAGE);
			AbstractSystemSolver.exit(1);
		}
		LinearSystemSolver l = new LinearSystemSolver(n);
		MatrixReader reader = new MatrixReader(l);
		AbstractSystemSolver.out.println("Ju lutem futeni matricn e zgjeruar t sistemit.");
		reader.readElements();
*/
		double[][] coeff =
			{{1, 2, 3, 4},
			 {1, 2, 0, 3},
			 {1, 0, 0, 2}};
		LinearSystemSolver l = new LinearSystemSolver(coeff);
		
//		l.gauss();
//		l.solveUpperTriangular();

		double[] initial = new double[l.getNumEquations()];
//		double[] initial = {0, 100000000, 0.001};
		l.setNumIterations(10);
		l.setTolerance(1E-5);
		
		new SystemDemoView(l);
		l.jacobi(initial);
		new SystemDemoView(l);
		l.gaussSeidel(initial);

/*		LinearSystemWriter writer = new LinearSystemWriter(l);
		writer.setPattern("0.0000");
		System.out.println("Zgjidhja e llogaritur:");
		writer.writeSolution();
*/
//		System.out.println("Matrica e zgjeruar pas transformimit:");
//		writer.writeMatrix();

	}
}
