/**
 * <p>File: MatrixWriter.java</p>
 * <p>Title: Numerical methods</p>
 * <p>Description: Course on numerical analysis</p>
 * <p>Date: June 2007</p>
 * @author Faton M. Berisha
 * @version 2.01
 */

package numeric;

/**
 * Writes a linear system.
 */
public class LinearSystemWriter {

//	private MatrixWriter matrixWriter;
	private MatrixWriter solutionWriter;
	
	/**
	 * Creates a linear system writer.
	 *  @param linear - the linear system to be written
	 */
	public LinearSystemWriter(LinearSystemSolver linear) {
//		matrixWriter = new MatrixWriter(linear.getMatrix());
		solutionWriter = new MatrixWriter(linear.getSolution());
	}
	
	/**
	 *  Writes the solution.
	 */
	public void writeSolution() {
		solutionWriter.writeMatrix();
	}
	
}
